﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimpleConsoleApp
{
    /// <summary>
    /// 分页信息
    /// </summary>
    [Serializable]
    public class PageInfo
    {
        /// <summary>
        /// 当前页
        /// </summary>
        public int CurrentPage { get; set; }

        /// <summary>
        /// 每页记录数
        /// </summary>
        public int RecordCount { get; set; }

        public int BeginRecordNumber
        {
            get
            {
                if (CurrentPage < 1)
                {
                    CurrentPage = 1;
                }
                return (CurrentPage - 1) * RecordCount + 1;
            }
        }

        public int EndRecordNumber
        {
            get
            {
                if (CurrentPage < 1)
                {
                    CurrentPage = 1;
                }
                return CurrentPage * RecordCount;
            }
        }

        /// <summary>
        /// 总记录数
        /// </summary>
        public int TotalCount { get; set; }
    }
}
