﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;

namespace SimpleConsoleApp
{
    class Program
    {
        private static readonly string strSqlConn = ConfigurationManager.ConnectionStrings["MySqlConnString"].ConnectionString;

        static void Main(string[] args)
        {
            Console.WriteLine("Start test...");
            //TestAdd();
            //TestUpdate();
            //TestBatchAdd();
            TestGet();
            //TestDelete();
            Console.WriteLine("End Test.");
            Console.Read();
        }

        /// <summary>
        /// 插入
        /// </summary>
        private static void TestAdd()
        {
            Console.WriteLine("Before add,truncate all persons:"); //清空表记录 truncate table test.Person
            MySqlHelper.ExecuteNonQuery(strSqlConn, "CleanPersons", CommandType.StoredProcedure);
            Console.WriteLine("truncate test.person end.");

            Console.WriteLine("add a person:");
            var paramKeys = new string[] { "@FirstName", "LastName", "@Age", "@CreateDate", "@UpdateDate", "@State", "@Remark" };
            var paramVals = new object[] { "jeff", "wong", 28, DateTime.Now, DateTime.Now, 1, "this is a simple add person test" };
            object personId = 0;
            for (int i = 0; i < 10; i++) //插入10条同名(FirstName+LastName)的记录
            {
                personId = MySqlHelper.ExecuteScalar(strSqlConn, "AddSimplePerson", CommandType.StoredProcedure,
                        MySqlHelper.PrepareParameters(paramKeys, paramVals), false);
                Console.WriteLine("added person id is:{0}", personId);
            }

            //Console.WriteLine("add a legal firstname person:");
            //paramVals = new object[] { "这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长这个名字长又长", 
            //    "wong", 28, DateTime.Now, DateTime.Now, 1, "this is a simple add person test" };
            //personId = MySqlHelper.ExecuteScalar(strSqlConn, "AddSimplePerson", CommandType.StoredProcedure,
            //        MySqlHelper.PrepareParameters(paramKeys, paramVals), false);
            // Console.WriteLine("added person id is:{0}", personId);

            for (int i = 1; i < 21; i++) //插入20条不同名的记录
            {
                paramKeys = new string[] { "v_FirstName", "v_LastName", "v_Age", "v_CreateDate", "v_UpdateDate", "v_State", "v_Remark" };
                paramVals = new object[] { string.Format("jeff{0}", i.ToString()), "wong", 26, DateTime.Now, DateTime.Now, 1,
                    string.Format("this is {0} diffrent name simple add person test",i.ToString()) };

                personId = MySqlHelper.ExecuteScalar(strSqlConn, "AddPerson", CommandType.StoredProcedure,
                     MySqlHelper.PrepareParameters(paramKeys, paramVals), false);
                Console.WriteLine("added person id is:{0}", personId);
            }

        }

        /// <summary>
        /// 批量插入
        /// </summary>
        private static void TestBatchAdd()
        {

            Console.WriteLine("Before batch add,truncate all persons:"); //清空表记录 truncate table test.Person
            MySqlHelper.ExecuteNonQuery(strSqlConn, "CleanPersons", CommandType.StoredProcedure);
            Console.WriteLine("truncate test.person end.");

            //DataTable dt = MySqlHelper.QueryForDataTable("GetAllPersons", CommandType.StoredProcedure, strSqlConn);
            //bool isOK = MySqlHelper.BatchInsert(strSqlConn, "test.people", dt); //无法通过sqlbulkcopy批量插入

            //string sqlString = "INSERT INTO test.Person(FirstName,LastName,Age,CreateDate,UpdateDate,State,Remark) VALUES";
            //int columes = 7;//需要插入的列数
            //var listObj = new List<object>();
            //for (int i = 0; i < 30; i++)   //拼接字符串，批量插入30条记录
            //{
            //    var paramVals = new object[] { string.Format("jeff{0}", columes * i), "wong", 28, DateTime.Now, DateTime.Now, 1, "this is a simple add person test" };
            //    listObj.AddRange(paramVals);
            //}

            //int affectNums = MySqlHelper.BatchInsert(sqlString, columes, listObj.ToArray(), strSqlConn, false); //无参数化插入
            //Console.WriteLine(affectNums);

            //int affectNums = MySqlHelper.BatchInsert(sqlString, columes, listObj.ToArray(), strSqlConn, true); //参数化插入
            //Console.WriteLine(affectNums);

            string[] columeArr = new string[] { "FirstName", "LastName", "Age", "CreateDate", "UpdateDate", "State", "Remark" };
            var listPersons = new List<Person>();
            Person person = null;
            for (int i = 0; i < 10000; i++)
            {
                person = new Person
                {
                    FirstName = string.Format("jeff{0}", i.ToString()),
                    LastName = "wong",
                    Age = 28,
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    State = 1,
                    Remark = string.Format("this is test person {0} ", i + 1)
                };
                listPersons.Add(person);
            }

            int affectNums = MySqlHelper.BatchInsert<Person>("test.Person", columeArr, listPersons, strSqlConn); //参数化插入
            Console.WriteLine(affectNums);

            var dt = MySqlHelper.QueryForDataTable("GetPersons", CommandType.StoredProcedure, strSqlConn); //取出所有记录
            affectNums = MySqlHelper.BatchInsert("test.Person", columeArr, dt, strSqlConn); //使用datatable批量插入
            Console.WriteLine(affectNums);

        }

        /// <summary>
        /// 查询
        /// </summary>
        private static void TestGet()
        {
            int id = 1;
            //通过下面这种传入Id的方式，实际取出的是所有记录，然后返回第一条
            //var person = MySqlHelper.QueryForObject<Person>("GetPersonById", CommandType.StoredProcedure, strSqlConn, "Id", id); 

            var person = MySqlHelper.QueryForObject<Person>("GetSimplePersonById", CommandType.StoredProcedure, strSqlConn, "v_Id", id); //取出一条记录

            if (person != null)
            {
                Console.WriteLine("the person name is:{0} {1}", person.FirstName, person.LastName);
            }

            var paramKeys = new string[] { "@v_FirstName", "@v_State" };
            var paramVals = new object[] { "ff", 1 };
            var listPerson = MySqlHelper.QueryForList<Person>("QueryPersons", CommandType.StoredProcedure, strSqlConn, paramKeys, paramVals);
            Console.WriteLine("you found {0} persons:", listPerson.Count);

            var pager = new PageInfo { CurrentPage = 1, RecordCount = 10 };
            paramKeys = new string[] { "CurrentPage", "RecordCount", "MinId" };
            paramVals = new object[] { pager.CurrentPage, pager.RecordCount, 0 };
            listPerson = MySqlHelper.QueryForList<Person>("GetPagerPersons", CommandType.StoredProcedure, strSqlConn, paramKeys, paramVals, pager);
            Console.WriteLine("page {0}, found {1} persons,total person:{2}", pager.CurrentPage, listPerson.Count, pager.TotalCount);
            var dictPerson = MySqlHelper.QueryForDictionary<int, Person>("Id", "GetPagerPersons", CommandType.StoredProcedure, strSqlConn, paramKeys, paramVals, pager);
            Console.WriteLine("page {0}, found {1} persons,total person:{2}", pager.CurrentPage, dictPerson.Count, pager.TotalCount);

            //高效分页查询
            int minId = listPerson.Count > 0 ? listPerson[listPerson.Count - 1].Id : 0;//第一页的最小ID
            pager = new PageInfo { CurrentPage = 2, RecordCount = 10 };
            paramKeys = new string[] { "CurrentPage", "RecordCount", "MinId" };
            paramVals = new object[] { pager.CurrentPage, pager.RecordCount, minId };
            listPerson = MySqlHelper.QueryForList<Person>("GetPagerPersons", CommandType.StoredProcedure, strSqlConn, paramKeys, paramVals, pager);
            Console.WriteLine("page {0}, found {1} persons,total person:{2}", pager.CurrentPage, listPerson.Count, pager.TotalCount);


        }

        /// <summary>
        /// 更新
        /// </summary>
        private static void TestUpdate()
        {
            var id = 1;
            string sql = "UPDATE test.Person SET Age=Age,UpdateDate=NOW() WHERE Id=Id;";
            var paramKeys = new string[] { "Age", "Id" };
            var paramVals = new object[] { 25, id };
            //这样写同样更新了所有记录,但是Age字段并没有更新
            var affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, sql, CommandType.Text, MySqlHelper.PrepareParameters(paramKeys, paramVals));
            Console.WriteLine("update affect rows:{0}", affectNum);

            //sql = "UPDATE test.Person SET Age=v_Age,UpdateDate=NOW() WHERE Id=v_Id;";
            //paramKeys = new string[] { "v_Age", "v_Id" };
            //paramVals = new object[] { 25, id };
            ////这样写抛出异常:Unknown column 'v_Id' in 'where clause'
            //affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, sql, CommandType.Text, MySqlHelper.PrepareParameters(paramKeys, paramVals));
            //Console.WriteLine("update affect rows:{0}", affectNum);

            sql = "UPDATE test.Person SET Age=@v_Age,UpdateDate=NOW() WHERE Id=@v_Id;";
            paramKeys = new string[] { "v_Age", "v_Id" };
            paramVals = new object[] { 25, id };
            //这样写更新一条记录成功
            affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, sql, CommandType.Text, MySqlHelper.PrepareParameters(paramKeys, paramVals));
            Console.WriteLine("update affect rows:{0}", affectNum);

            sql = "UPDATE test.Person SET Age=Age+1,UpdateDate=NOW() WHERE Id=@v_Id;";
            paramKeys = new string[] { "v_Id" };
            paramVals = new object[] { id };
            //这样写更新一条记录也是成功的
            affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, sql, CommandType.Text, MySqlHelper.PrepareParameters(paramKeys, paramVals));
            Console.WriteLine("update affect rows:{0}", affectNum);

            Console.Read();

            var person = MySqlHelper.QueryForObject<Person>("GetSimplePersonById", CommandType.StoredProcedure, strSqlConn, "v_Id", id);
            if (person == null)
            {
                return;
            }
            Console.WriteLine("update a person,id is:{0}", person.Id);
            //paramKeys = new string[] { "Id", "FirstName", "LastName", "Age", "CreateDate", "UpdateDate", "State", "Remark" };
            paramKeys = new string[] { "v_Id", "v_FirstName", "v_LastName", "v_Age", "v_CreateDate", "v_UpdateDate", "v_State", "v_Remark" };
            paramVals = new object[] { person.Id, "jeff", "wong", 25, person.CreateDate, DateTime.Now, 0, "this is a simple update person test" };

            //下面这行竟然更新了所有
            //affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, "UpdatePerson", CommandType.StoredProcedure, MySqlHelper.PrepareParameters(paramKeys, paramVals), true);

            affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, "UpdateSimplePerson", CommandType.StoredProcedure, MySqlHelper.PrepareParameters(paramKeys, paramVals), true);
            Console.WriteLine("update affect rows:{0}", affectNum);
        }

        /// <summary>
        /// 删除
        /// </summary>
        private static void TestDelete()
        {
            int affectNum = 0;
            Console.WriteLine("delete persons with the samle firstname:");
            affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, "DeleteDuplicatePerson", CommandType.StoredProcedure);  //删除同名(FirstName+LastName)的记录
            Console.WriteLine("as you can see,we delete {0} records.", affectNum);

            Console.WriteLine("delete a person:");

            for (int i = 11; i < 21; i++)
            {
                ////这样传参会造成误删除所有记录
                //affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, "DeletePerson", CommandType.StoredProcedure, MySqlHelper.PrepareParameter("Id", i));

                affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, "DeletePerson", CommandType.StoredProcedure, MySqlHelper.PrepareParameter("v_Id", i));
                Console.WriteLine("delete affect rows:{0}", affectNum);
            }
            Console.WriteLine("truncate all persons:");
            affectNum = MySqlHelper.ExecuteNonQuery(strSqlConn, "CleanPersons", CommandType.StoredProcedure);

            Console.WriteLine("after truncate,add a person:");

            var paramKeys = new string[] { "v_FirstName", "v_LastName", "v_Age", "v_CreateDate", "v_UpdateDate", "v_State", "v_Remark" };
            var paramVals = new object[] { "jeff", "wong", 28, DateTime.Now, DateTime.Now, 1, "this is a simple add person test" };
            var personId = MySqlHelper.ExecuteScalar(strSqlConn, "AddPerson", CommandType.StoredProcedure,
                   MySqlHelper.PrepareParameters(paramKeys, paramVals), false);
            Console.WriteLine("as you see,the return autoincrement id is :{0}", personId);

        }

    }
}
